#include <stdio.h>

#define YESNO(option) ((option)? "yes": "no")

int main() {
   int device; cudaGetDevice(&device);
   int device_count; cudaGetDeviceCount(&device_count);
   struct cudaDeviceProp device_prop;
   cudaGetDeviceProperties(&device_prop, device);
   if (device_count > 1) {
      printf("device %d selected out of %d devices:\n", device, device_count);
   } else {
      printf("one device present:\n");
   }
   printf("name: %s\n", device_prop.name);
   printf("compute capability: %d.%d\n", device_prop.major, device_prop.minor);
   printf("total global memory: %d\n", device_prop.totalGlobalMem);
   printf("total shared memory per block: %d\n", device_prop.sharedMemPerBlock);
   printf("registers per block: %d\n", device_prop.regsPerBlock);
   printf("warp size: %d\n", device_prop.warpSize);
   printf("mem pitch: %d\n", device_prop.memPitch);
   printf("max threads per block: %d\n", device_prop.maxThreadsPerBlock);
   printf("max threads dim: %d %d %d\n", device_prop.maxThreadsDim[0],
      device_prop.maxThreadsDim[1], device_prop.maxThreadsDim[2]);
   printf("max grid dim: %d %d %d\n", device_prop.maxGridSize[0],
      device_prop.maxGridSize[1], device_prop.maxGridSize[2]);
   printf("multi processor count: %d\n", device_prop.multiProcessorCount);
   printf("kernel exec timeout enabled: %s\n",
      YESNO(device_prop.kernelExecTimeoutEnabled));
   printf("integrated: %s\n",
      YESNO(device_prop.integrated));
   printf("can map host memory: %s\n",
      YESNO(device_prop.canMapHostMemory));
}
